ALK/Controllers/MyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ALK.Models;

namespace ALK.Models
{
    public class DataFilex
    { 
        public int Id { get; set; }
        public string Name { get; set; }
        public string ContentType { get; set; }
        public int UsedCount { get; set; }
    }
}

namespace ALK.Controllers
{
    public class MyController : Controller
    {
        static string Logi = "";
        protected UsedGamesEntities db = new UsedGamesEntities();

        [OutputCache(VaryByParam ="*", Location = System.Web.UI.OutputCacheLocation.ServerAndClient, Duration =3600)]

        public ActionResult Content(int id)
        {
            DateTime s = DateTime.Now;
            DataFile df = db.DataFiles.Find(id);
            if (df == null) return HttpNotFound();
            Logi += $"Laadisin {id} - {(DateTime.Now-s).TotalMilliseconds}\n";
            return File(df.Content, df.ContentType);

        }

        public string GetLogi() => Logi;

        [HttpPost]
        public ActionResult Index(HttpPostedFileBase file)
        {
            if (file != null)
            {
                using (System.IO.BinaryReader br = new System.IO.BinaryReader(file.InputStream))
                {
                    db.DataFiles.Add(
                        new DataFile
                        {
                            Name = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength)
                        }
                        );
                    db.SaveChanges();
                }
            }

            return RedirectToAction("Index");
        }

        public ActionResult Index()
        {
            return View(db.DataFiles.Select(x => new DataFilex {Id =x.Id, Name =x.Name, ContentType = x.ContentType, UsedCount = x.ProductImages.Count } ).ToList());
        }


    }
}

ALK/Controllers/ProductsAdminController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using ALK.Models;


namespace ALK.Controllers
{
    public class ProductsAdminController : Controller
    {
        private UsedGamesEntities db = new UsedGamesEntities();

        // GET: ProductsAdmin
        [Authorize(Roles = "Admin")]
        public ActionResult Index()
        {
            var products = db.Products.Include(p => p.AspNetUser).Include(p => p.Category);

            products = products.Where(x => x.DefaultImage == null);
            return View(products.Select(x => new ProductX { Product = x, FirstImageId = x.ProductImages.Select(y => y.ImageId).FirstOrDefault() }).ToList());
        }

        // GET: ProductsAdmin/Details/5
        [Authorize(Roles = "Admin")]
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }

            ViewBag.ImageId = product.ProductImages.FirstOrDefault()?.ImageId;
            ViewBag.CategoryId = new SelectList(db.Categories.Where(x => x.Title != "Kõik kategooriad"), "Id", "Title", product.CategoryId);
            ViewBag.ProductID = product.Id;

            if (product.DefaultImage != null) return HttpNotFound();
            return View(product);


        }

        // GET: ProductsAdmin/Create
        [Authorize(Roles = "Admin")]
        public ActionResult Create()
        {
            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email");
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title");
            return View();
        }

        // POST: ProductsAdmin/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,UserId,Available,ProductName,Description,Price,Created,Starting,PCount,CategoryId,DefaultImage")] Product product, IEnumerable<HttpPostedFileBase> file)
        {
            if (ModelState.IsValid)
            {
                {
                    foreach (var item in file)
                    {
                        if (item == null) break;
                        using (System.IO.BinaryReader br = new System.IO.BinaryReader(item.InputStream))
                        {
                            var df = new DataFile
                            {
                                Content = br.ReadBytes(item.ContentLength),
                                Name = item.FileName.Split('\\').Last().Split('/').Last(),
                                ContentType = item.ContentType
                            };

                            db.DataFiles.Add(df);

                            db.Set<ProductImage>().Add(new ProductImage()
                            {
                                ProductId = product.Id,
                                Description = "Create from controller",
                                DataFile = df
                            });
                        }
                    }
                }

                if (product.ProductName == null) return RedirectToAction("Create");
                product.Created = DateTime.Now;
                db.Products.Add(product);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);
            return View(product);
        }

        // GET: ProductsAdmin/Edit/5
        [Authorize(Roles = "Admin")]
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }

            ViewBag.ImageId = product.ProductImages.FirstOrDefault()?.ImageId;
            ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
            ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);
            ViewBag.ProductID = product.Id;

            if (product.DefaultImage != null) return HttpNotFound();
            return View(product);
        }

        // POST: ProductsAdmin/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,UserId,Available,ProductName,Description,Price,Created,Starting,PCount,CategoryId,DefaultImage")] string oldImageId, Product product, HttpPostedFileBase file)
        {
         if (ModelState.IsValid)
            {
                product.Created = DateTime.Now;
                db.Entry(product).State = EntityState.Modified;
               
                
                db.SaveChanges();
                if (file != null && file.ContentLength > 0)
                {
                    using (System.IO.BinaryReader br = new System.IO.BinaryReader(file.InputStream))
                    {
                        var df = new DataFile
                        {
                            Content = br.ReadBytes(file.ContentLength),
                            Name = file.FileName.Split('\\').Last().Split('/').Last(),
                            ContentType = file.ContentType
                        };

                        db.DataFiles.Add(df);
                        db.Set<ProductImage>().Add(new ProductImage()
                        {
                            ProductId = product.Id,
                            Description = "Create from controller",
                            DataFile = df
                        });

                        db.SaveChanges();
                    }
                }

                return RedirectToAction("Edit/" + product.Id);
            }
             ViewBag.UserId = new SelectList(db.AspNetUsers, "Id", "Email", product.UserId);
             ViewBag.CategoryId = new SelectList(db.Categories, "Id", "Title", product.CategoryId);
            return View(product);
        }

        // GET: ProductsAdmin/Delete/5
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            return View(product);
        }

        // POST: ProductsAdmin/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Product product = db.Products.Find(id);
            product.DefaultImage = 1;
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

        public ActionResult RemovePicutre(int PicturesId, int ProductId)
        {
            var item1 = db.ProductImages.Where(x => x.ImageId == PicturesId).ToList();
            foreach (var item in item1)
            {
                db.ProductImages.Remove(item);
                var item2 = db.DataFiles.Find(item.ImageId);
                db.DataFiles.Remove(item2);
            }
            db.SaveChanges();

            return RedirectToAction("Edit/" + ProductId);
        }
    }
}

ALK/Views/ProductsAdmin/Create.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Create";
}

<h2>Create</h2>


@using (Html.BeginForm("Create", "ProductsAdmin", FormMethod.Post, new { enctype = "multipart/form-data" })) 
{
    @Html.AntiForgeryToken()
    
<div class="form-horizontal">
    <h4>Product</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="form-group">
        @Html.LabelFor(model => model.UserId, "UserId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("UserId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Available, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            <div class="checkbox">
                @Html.EditorFor(model => model.Available)
                @Html.ValidationMessageFor(model => model.Available, "", new { @class = "text-danger" })
            </div>
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Price, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Price, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Price, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PCount, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.PCount, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.PCount, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        <label class="control-label col-md-2">Add picture</label>
        <div class="col-md-10">
            <input type="file" name="file" id="file" multiple />
        </div>
    </div>

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Create" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Back to Products", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

ALK/Views/ProductsAdmin/Delete.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>

        </dt>

        <dd>
            <img height="100" src="@Url.Action("Content", "My", new { id = Model.ProductImages.FirstOrDefault()?.DataFile.Id })" />
        </dd>
        <dt>
            @Html.DisplayNameFor(model => model.Available)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Available)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProductName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Price)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Price)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Created)
        </dt>
        <dt>
            @Html.DisplayNameFor(model => model.PCount)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PCount)
        </dd>
        <dt>
            @Html.DisplayNameFor(model => model.AspNetUser.Email)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AspNetUser.Email)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Category.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Category.Title)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to Products", "Index")
        </div>
    }
</div>

ALK/Views/ProductsAdmin/Details.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Details";
}

<h2>Details</h2>

<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Available)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Available)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProductName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Price)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Price)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Created)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Created)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Starting)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Starting)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PCount)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PCount)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DefaultImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DefaultImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.AspNetUser.Email)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AspNetUser.Email)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Category.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Category.Title)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Back to List", "Index")
</p>

ALK/Views/ProductsAdmin/Edit.cshtml
@model ALK.Models.Product

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm("Edit", "ProductsAdmin", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Product</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)

        <div class="form-group">
            @Html.LabelFor(model => model.UserId, "UserId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("UserId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Available, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <div class="checkbox">
                    @Html.EditorFor(model => model.Available)
                    @Html.ValidationMessageFor(model => model.Available, "", new { @class = "text-danger" })
                </div>
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Price, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Price, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Price, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Created, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Starting, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Starting, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Starting, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PCount, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PCount, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PCount, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
            </div>
        </div>


        <input type="hidden" name="oldImageId" id="oldImageId" value="@ViewBag.ImageId" />

        <div class="form-group">
            <label class="control-label col-md-2">Change picture</label>
            <div class="col-md-10">
                <input type="file" name="file" id="file" />
            </div>
        </div>

        <div class="form-group">
            @foreach (var item in Model.ProductImages)
            {

                <label class="control-label col-md-2">
                    <img src="@Url.Action("Content", "My", new { id = item.ImageId})" height="140" class="col-md-10">
                    <a href="@Url.Action("RemovePicutre","Products",new {PicturesId =item.ImageId, ProductId= item.ProductId  })">Delete</a>
                </label>

            }
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}


<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

<script>
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#pilt').attr('src', e.target.result); 
            }

            reader.readAsDataURL(input.files[0]);
        }
    }
   
    $(document).ready(function () {
        $("#file").change(function () {
            readURL(this);
        });
    });

</script>

ALK/Views/ProductsAdmin/Index.cshtml
@model IEnumerable<ALK.Models.ProductX>

@{
    ViewBag.Title = "Index";
}


<a href="@Url.Action("Index","AspNetUsers")" style="float:right;font-size:25px" class="btn btn-info">User administration</a>
<a href="@Url.Action("Index","OrderAdmin")" style="float:right; margin-right:25px;font-size:25px" class="btn btn-info">Order administration</a>

<h2>Product administration</h2>
<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
        </th>
        <th>
            Category
        </th>
        <th>
            Product Name
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Product.Available)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Product.Description)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Product.Price)
        </th>
        <th>
            Amount
        </th>
        <th>
            Seller
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Product.AspNetUser.Email)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Product.Created)
        </th>

        <th></th>
    </tr>

@foreach (var item in Model) {
<tr>
    <td>
        <img height="100" src="@Url.Action("Content", "My", new { id = item.FirstImageId})" />
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.Category.Title)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.ProductName)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.Available)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.Description)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.Price)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.PCount)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.AspNetUser.DisplayName)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.AspNetUser.Email)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Product.Created)
    </td>
    <td>
        @Html.ActionLink("Edit", "Edit", new { id = item.Product.Id }) |
        @Html.ActionLink("View", "Details", new { id = item.Product.Id }) |
        @Html.ActionLink("Delete", "Delete", new { id = item.Product.Id })
    </td>
</tr>
}

</table>